// FOTODUINO_grafico_1_0

// Codigo de aplicativo para os experimentos do plasma e efeito foto eletrico

//Efeito fotoeletrico - grafico e controle

//import com.yourinventit.processing.android.serial.*; //Remover comentario para android

//Variaveis globais
import processing.serial.*; //Comentar para android

PImage imgon,imgoff,seta,mnpef;
Serial myPort;
int xPos = 20;
int he=580;
float antes=0;
int i=1;
float inByte=0;
int xmax=3222;
int xmin=0;
float coord=1500;
boolean calllinhas = true;
boolean uva = false;
boolean uvc = false;
boolean verm = false;
boolean azul = false;
boolean amar = false;
boolean verde = false;
boolean dado = false;

void setup () { //funcao principal

size(600, 600); // tamanho da janela grafica

imgon = loadImage("botaoon.jpg"); //carregamento das imagens
imgoff = loadImage("botaooff.jpg");
seta = loadImage("seta.jpg");
mnpef = loadImage("mnpef.jpg");

//Inicializacao da porta
printArray(Serial.list());//Comente para android
//configuracao da porta modifique o numero [32] para [0] ou outro caso nao inicie o app.
myPort = new Serial(this, Serial.list()[32], 115200);//Comente para android
//println(Serial.list(this));//Remover comentario para android
//myPort = new Serial(this, Serial.list(this)[0], 115200);//Remover comentario para android
myPort.bufferUntil('\n');
background(240);
}

void draw(){
//Desenho da tela
if(calllinhas){
    linhas();
    calllinhas = false;
    }
if(dado){
stroke(0,0,255);
line(xPos, he-antes, xPos+1, he-inByte);
antes=inByte;
if (xPos >= he-20) {
  xPos = 20;
  background(240);
  linhas();
 }
else {
 xPos++;
 }
}
dado=false;
}



void linhas(){

fill(0,0,0);
textSize(36);
text("FOTODUINO",180,40 );
textSize(12);
fill(0,0,255);
text("Acionamento das lampadas",210,80);
text("Ajuste de escala",435,270);
text("Corrente versus Tempo",210,295);
fill(0,0,0);
text("UVC",525,170);
text("UVA",425,170);
text("Reset",470,250);
text("Auto",470,210);
text("APAGAR",330,230);
text("0",5,440);
text("+",5,300);
text("-",5,580);


stroke(0,0,0);
//Linhas do grafico
line(15,300,15,580);
line(15,580,580,580);
line(580,300,580,580);
line(15,300,580,300);
line(15,440,580,440);

//Logo mnpef
tint(255,255,255);
image(mnpef, 10, 190,300,50);
//Botoes de acionamento das lampadas
tint(255,0,0);
if(verm){image(imgon, 10, 100,50,50);}
else{image(imgoff, 10, 100,50,50);}
tint(255,255,0);
if(amar){image(imgon, 110, 100,50,50);}
else{image(imgoff, 110, 100,50,50);}
tint(0,255,0);
if(verde){image(imgon, 210, 100,50,50);}
else{image(imgoff, 210, 100,50,50);}
tint(0,0,255);
if(azul){image(imgon, 310, 100,50,50);}
else{image(imgoff, 310, 100,50,50);}
tint(255,200,255);
if(uva){image(imgon, 410, 100,50,50);}
else{image(imgoff, 410, 100,50,50);}
tint(255,0,255);
if(uvc){image(imgon, 510, 100,50,50);}
else{image(imgoff, 510, 100,50,50);}


//Botoes de escala
tint(255,255,255);
image(seta, 510, 200,50,50);
image(seta,410, 200,50,50);

}


void mousePressed() {
  println("Coordinates: " + mouseX +"," + mouseY);
  mouseAction();
    }

void mouseAction(){

//Botao de limpar
 if( mouseX > 330 && mouseX < 380){
   if( mouseY > 220 && mouseY < 230){
       xPos = 20;
       background(240);
       linhas();
       println("limpar");
   }
  }
  
//Botao de reset de escala
 if( mouseX > 470 && mouseX < 500){
   if( mouseY > 240 && mouseY < 250){
     xmin=0;
     xmax=3222;
     println("reset");

   }
  }
  
//Botao auto-escala
 if( mouseX > 470 && mouseX < 500){
   if( mouseY > 200 && mouseY < 210){
     xmin=int(coord)-200;
     xmax=int(coord)+200;
     println("auto");

   }
  } 
  
  
//Acoes dos botoes de escala do grafico  
   if( mouseX > 510 && mouseX < 560){
   if( mouseY > 200 && mouseY < 225){
     xmax=xmax+100;
     println(xmax);

   }
  }
   if( mouseX > 510 && mouseX < 560){
   if( mouseY > 225 && mouseY < 250){
     if(xmax>xmin+100){
     xmax=xmax-100;
     println(xmax);}

   }
  }
  
   if( mouseX > 410 && mouseX < 460){
   if( mouseY > 200 && mouseY < 225){
     if(xmin<xmax-100){
     xmin=xmin+100;
     println(xmin);}

   }
  }

   if( mouseX > 410 && mouseX < 460){
   if( mouseY > 225 && mouseY < 250){
     xmin=xmin-100;
     println(xmin);

   }
  }

//Acoes dos botoes de acionamento das lampadas   
   if( mouseX > 10 && mouseX < 60){
   if( mouseY > 100 && mouseY < 125){
     println("square 11");
     myPort.write(11);
     if(verm==false){
     tint(255,0,0);
     image(imgon, 10, 100,50,50);
     verm=true;
     }
   }
  }

   if( mouseX > 10 && mouseX < 60){
   if( mouseY > 125 && mouseY < 150){
     println("square 10");
     myPort.write(10);
     if(verm){
     tint(255,0,0);
     image(imgoff, 10, 100,50,50);
     verm=false;
     }
   }
  }

   if( mouseX > 110 && mouseX < 160){
   if( mouseY > 100 && mouseY < 125){
    println("square 21");
    myPort.write(21);
    if(amar==false){
    tint(255,255,0);
    image(imgon, 110, 100,50,50);
    amar=true;
    }
   }
  }
  
   if( mouseX > 110 && mouseX < 160){
   if( mouseY > 125 && mouseY < 150){
    println("square 20");
    myPort.write(20);
    if(amar){
    tint(255,255,0);
    image(imgoff, 110, 100,50,50);
    amar=false;
    }
   }
  }
  
  
   if( mouseX > 210 && mouseX < 260){
   if( mouseY > 100 && mouseY < 125){
    println("square 31");
    myPort.write(31);
    if(verde==false){
    tint(0,255,0);
    image(imgon, 210, 100,50,50);
    verde=true;
    }
   }
  }
  
   if( mouseX > 210 && mouseX < 260){
   if( mouseY > 125 && mouseY < 150){
    println("square 30");
    myPort.write(30);
    if(verde){
    tint(0,255,0);
    image(imgoff, 210, 100,50,50);
    verde=false;
    }
   }
  }

   if( mouseX > 310 && mouseX < 360){
   if( mouseY > 100 && mouseY < 125){
    println("square 41");
    myPort.write(41);
    if(azul==false){
    tint(0,0,255);
    image(imgon, 310, 100,50,50);
    azul=true;
    }
   }
  }  
  
   if( mouseX > 310 && mouseX < 360){
   if( mouseY > 125 && mouseY < 150){
    println("square 40");
    myPort.write(40);
    if(azul){
    tint(0,0,255);
    image(imgoff, 310, 100,50,50);
    azul=false;
    }
   }
  }
  

   if( mouseX > 410 && mouseX < 460){
   if( mouseY > 100 && mouseY < 125){
    println("square 51");
    myPort.write(51);
    if(uva==false){
    tint(255,200,255);
    image(imgon, 410, 100,50,50);
    uva=true;
    }
   }
  }
  
   if( mouseX > 410 && mouseX < 460){
   if( mouseY > 125 && mouseY < 150){
    println("square 50");
    myPort.write(50);
    if(uva){
    tint(255,200,255);
    image(imgoff, 410, 100,50,50);
    uva=false;
   }
   }
  }  


   if( mouseX > 510 && mouseX < 560){
   if( mouseY > 100 && mouseY < 125){
    println("square 61");
    myPort.write(61);
    if(uvc==false){
    tint(255,0,255);
    image(imgon, 510, 100,50,50);
    text("UVC liga",xPos,400);
    uvc=true;
    }
   }
  }
  
   if( mouseX > 510 && mouseX < 560){
   if( mouseY > 125 && mouseY < 150){
    println("square 60");
    myPort.write(60);
    if(uvc){
    uvc=false;
    text("UVC desliga",xPos,400);
    tint(255,0,255);
    image(imgoff, 510, 100,50,50);
    }
   }
  }

}


//Leitura de dados da serial
void serialEvent (Serial myPort) {
String inString = myPort.readStringUntil('\n');
if (inString != null) {
inString = trim(inString);
//inByte = 3222-float(inString);//Inverte o grafico
inByte = float(inString);
coord=inByte;
inByte = map(inByte, xmin, xmax, 0, 280);
dado=true;
}
}

 
